//////////////////////////////////////////////////
////////Mainscript for the Shadow Project/////////
//////////////////////////////////////////////////
//////////////////////////////////////////////////
/////24.12.2008////////////////by Nils Daumann////
///////////////www.ssmasters.de///////////////////
//////////////////////////////////////////////////


//Paths
#define PRAGMA_PATH "Models"
#define PRAGMA_PATH "Textures"
#define PRAGMA_PATH "Scripts"


//Includes
#include <acknex.h>
#include <default.c>

#include "OS_O_Normalmapping.c"


//Include the Shadows
#define PRAGMA_PATH "Shadows"
#include "SM_Main.c"


//Global Variables
ENTITY* SpotEnt = NULL;
ENTITY* ProjEnt = NULL;

//Skycube
ENTITY* SkyObject =
{
	type = "Himmel1+6.tga";
	flags2 = SKY|CUBE|VISIBLE;
}

void main()
{
	video_screen = 2;
	video_mode = 10;
	
	d3d_anisotropy = 16;
	level_load("vsm.wmb");
	wait(3);
	
	//Activate the shadows
	SM_CreateSun(100.0, 4, 0.1, 1000, 1024, 14);
	SM_CreatePointlights(1, 512);
	SM_CreateSpotlights(512, SpotEnt,NULL);
	SM_CreateCubeProj(ProjEnt, NULL);
	
	//Set shadow ambient
	SM_setAmbient(120);
	
	while(1)
	{
		sun_angle.pan += time_step;
		sun_angle.tilt = 60;
		wait(1);
	}
}

action Spotlight_act()
{
	SpotEnt = my;
	ent_clone(my);
	wait(1);
	ent_setskin(my,bmap_create("SpotProj.dds"),1);
	my.skill1 = 2000;	//shadowrange
	my.skill2 = 1;		//light power
	my.skill3 = 60;	//light arc
	my.skill4 = 1;		//light aspect
	
	var startx;
	startx = my.x;
	
	while(1)
	{
		my.pan += 5*time_step;
		my.tilt = -90+sin(my.pan)*10;
		my.x = startx+sin(my.pan)*10;
		
		wait(1);
	}
}

action CubeProj_act()
{
	ProjEnt = my;
	ent_clone(my);
	wait(1);
	ent_setskin(my,bmap_create("Cubeproj.dds"),1);
	my.skill1 = 300;
	my.skill2 = 1;
	
	while(1)
	{
		my.pan -= 5*time_step;
		my.tilt += 5*time_step;
		my.roll -= 5*time_step;
		
		wait(1);
	}
}
