//////////////////////////////////////////////////
///////////////Cubemap Projection/////////////////
//////////////////////////////////////////////////
//////////////////////////////////////////////////
////24.12.2008////////////////by Nils Daumann/////
///////////////www.ssmasters.de///////////////////
//////////////////////////////////////////////////

#ifndef SM_CUBEPROJ
#define SM_CUBEPROJ

var SM_CubeProj_Active_var = 0;

MATERIAL* SM_CubeProj_Main_mat =
{
	effect = "SM_CubeProj_main.fx";
}

#ifndef SM_COMBINE
#define SM_COMBINE
	MATERIAL* SM_Combine_mat =
	{
		effect = "SM_Combine.fx";
	}
#endif

void SM_CubeProj_delete()
{
	SM_CubeProj_Active_var = 0;
}

void SM_CreateCubeProj(ENTITY* ent1, ENTITY* ent2)
{
	SM_CubeProj_delete();
	wait(1);
	
	proc_mode = PROC_LATE;
	
	if(ent1 != NULL)
		SM_CubeProj_Main_mat.skin1 = bmap_to_cubemap(ent_getskin(ent1,1));
	if(ent2 != NULL)
		SM_CubeProj_Main_mat.skin2 = bmap_to_cubemap(ent_getskin(ent2,1));
	
	VIEW* mainview;
	mainview = view_create(-1);
	
	mainview.material = SM_CubeProj_Main_mat;
	mainview.size_x = screen_size.x;
	mainview.size_y = screen_size.y;
	SM_Combine_mat.skin3 = bmap_createblack(screen_size.x,screen_size.y,32);
	mainview.bmap = SM_Combine_mat.skin3;
	set(mainview,VISIBLE);
	
	PP_Remove(SM_Combine_mat,camera,NULL);
	PP_Add(SM_Combine_mat,camera,NULL);
	
	SM_Combine_mat.skill3 = floatv(1);
	
	float pi = 3.14159265;
	
	SM_CubeProj_Active_var = 1;
	while(SM_CubeProj_Active_var)
	{
		vec_set(mainview.x,camera.x);
		vec_set(mainview.pan,camera.pan);
		mainview.genius = camera.genius;
		mainview.clip_near = camera.clip_near;
		mainview.clip_far = camera.clip_far*0.2;
		mainview.arc = camera.arc;
		
		if(ent1 != NULL)
		{
			SM_CubeProj_Main_mat.skill1 = floatv(ent1.x);
			SM_CubeProj_Main_mat.skill2 = floatv(ent1.z);
			SM_CubeProj_Main_mat.skill3 = floatv(ent1.y);
			
			SM_CubeProj_Main_mat.skill9 = floatv(-ent1.pan*pi/180);
			SM_CubeProj_Main_mat.skill10 = floatv(ent1.tilt*pi/180);
			SM_CubeProj_Main_mat.skill11 = floatv(-ent1.roll*pi/180);
			
			SM_CubeProj_Main_mat.skill4 = floatv(ent1.skill1);
			SM_CubeProj_Main_mat.skill17 = floatv(ent1.skill2);
		}
		
		if(ent2 != NULL)
		{
			SM_CubeProj_Main_mat.skill5 = floatv(ent2.x);
			SM_CubeProj_Main_mat.skill6 = floatv(ent2.z);
			SM_CubeProj_Main_mat.skill7 = floatv(ent2.y);
			
			SM_CubeProj_Main_mat.skill12 = floatv(-ent2.pan*pi/180);
			SM_CubeProj_Main_mat.skill13 = floatv(ent2.tilt*pi/180);
			SM_CubeProj_Main_mat.skill14 = floatv(-ent2.roll*pi/180);
			
			SM_CubeProj_Main_mat.skill8 = floatv(ent2.skill1);
			SM_CubeProj_Main_mat.skill18 = floatv(ent2.skill2);
		}
		
		wait(1);
	}
	
	SM_Combine_mat.skill3 = floatv(0);
}

#endif
