//////////////////////////////////////////////////
////////////Pointlight Shadowmapping//////////////
//////////////////////////////////////////////////
//////////////////////////////////////////////////
////24.12.2008////////////////by Nils Daumann/////
///////////////www.ssmasters.de///////////////////
//////////////////////////////////////////////////

#ifndef SM_POINTLIGHTS
#define SM_POINTLIGHTS

var SM_Point_Active_var = 0;

MATERIAL* SM_Point_Main_mat =
{
	effect = "SM_PointLights_main.fx";
}

MATERIAL* SM_Point_Depth_mat =
{
	effect = "SM_VSM_depth.fx";
}

#ifndef SM_COMBINE
#define SM_COMBINE
	MATERIAL* SM_Combine_mat =
	{
		effect = "SM_Combine.fx";
	}
#endif

void SM_Point_delete()
{
	SM_Point_Active_var = 0;
}

void SM_Point_setView(VIEW* input, VIEW* output)
{
	vec_set(output.x,input.x);
	output.clip_near = input.clip_near;
	output.clip_far = input.clip_far;
}

void SM_CreatePointlights(var numlights, var resolution)
{
	SM_Point_delete();
	wait(1);
	
	if(numlights == 0)
		return;
	
	numlights = clamp(numlights,1,4);
	
	proc_mode = PROC_LATE;
	
	VIEW** shadowviews;
	shadowviews = malloc(sizeof(VIEW*)*numlights*6);
	
	BMAP** shadowbmaps;
	shadowbmaps = malloc(sizeof(BMAP*)*numlights);
	
	VIEW* mainview;
	mainview = view_create(-1);
	
	int i;
	for(i = 0; i < numlights; i++)
	{
		shadowbmaps[i] = bmap_createblack(resolution*6,resolution,14444);
		bmap_to_cubemap(shadowbmaps[i]);
		
		shadowviews[i*6+0] = view_create(-2);
		shadowviews[i*6+0].material = SM_Point_Depth_mat;
		shadowviews[i*6+0].arc = 90;
		shadowviews[i*6+0].pan = 180;
		shadowviews[i*6+0].tilt = 0;
		shadowviews[i*6+0].roll = 0;
		shadowviews[i*6+0].bmap = shadowbmaps[i];
		shadowviews[i*6+0].pos_x = 0;
		shadowviews[i*6+0].size_x = resolution;
		shadowviews[i*6+0].size_y = resolution;
		set(shadowviews[i*6+0],VISIBLE);
		
		shadowviews[i*6+1] = view_create(-2);
		shadowviews[i*6+1].material = SM_Point_Depth_mat;
		shadowviews[i*6+1].arc = 90;
		shadowviews[i*6+1].pan = 90;
		shadowviews[i*6+1].tilt = 0;
		shadowviews[i*6+1].roll = 0;
		shadowviews[i*6+1].bmap = shadowbmaps[i];
		shadowviews[i*6+1].pos_x = resolution;
		shadowviews[i*6+1].size_x = resolution;
		shadowviews[i*6+1].size_y = resolution;
		set(shadowviews[i*6+1],VISIBLE);
		
		shadowviews[i*6+2] = view_create(-2);
		shadowviews[i*6+2].material = SM_Point_Depth_mat;
		shadowviews[i*6+2].arc = 90;
		shadowviews[i*6+2].pan = 0;
		shadowviews[i*6+2].tilt = 0;
		shadowviews[i*6+2].roll = 0;
		shadowviews[i*6+2].bmap = shadowbmaps[i];
		shadowviews[i*6+2].pos_x = resolution*2;
		shadowviews[i*6+2].size_x = resolution;
		shadowviews[i*6+2].size_y = resolution;
		set(shadowviews[i*6+2],VISIBLE);
		
		shadowviews[i*6+3] = view_create(-2);
		shadowviews[i*6+3].material = SM_Point_Depth_mat;
		shadowviews[i*6+3].arc = 90;
		shadowviews[i*6+3].pan = 270;
		shadowviews[i*6+3].tilt = 0;
		shadowviews[i*6+3].roll = 0;
		shadowviews[i*6+3].bmap = shadowbmaps[i];
		shadowviews[i*6+3].pos_x = resolution*3;
		shadowviews[i*6+3].size_x = resolution;
		shadowviews[i*6+3].size_y = resolution;
		set(shadowviews[i*6+3],VISIBLE);
		
		shadowviews[i*6+4] = view_create(-2);
		shadowviews[i*6+4].material = SM_Point_Depth_mat;
		shadowviews[i*6+4].arc = 90;
		shadowviews[i*6+4].pan = 90;
		shadowviews[i*6+4].tilt = -90;
		shadowviews[i*6+4].roll = 0;
		shadowviews[i*6+4].bmap = shadowbmaps[i];
		shadowviews[i*6+4].pos_x = resolution*4;
		shadowviews[i*6+4].size_x = resolution;
		shadowviews[i*6+4].size_y = resolution;
		set(shadowviews[i*6+4],VISIBLE);
		
		shadowviews[i*6+5] = view_create(-2);
		shadowviews[i*6+5].material = SM_Point_Depth_mat;
		shadowviews[i*6+5].arc = 90;
		shadowviews[i*6+5].pan = 90;
		shadowviews[i*6+5].tilt = 90;
		shadowviews[i*6+5].roll = 0;
		shadowviews[i*6+5].bmap = shadowbmaps[i];
		shadowviews[i*6+5].pos_x = resolution*5;
		shadowviews[i*6+5].size_x = resolution;
		shadowviews[i*6+5].size_y = resolution;
		set(shadowviews[i*6+5],VISIBLE);
		
		switch(i)
		{
			case 0:
				SM_Point_Main_mat.skin1 = shadowbmaps[i];
				break;
			
			case 1:
				SM_Point_Main_mat.skin2 = shadowbmaps[i];
				break;
			
			case 2:
				SM_Point_Main_mat.skin3 = shadowbmaps[i];
				break;
			
			case 3:
				SM_Point_Main_mat.skin4 = shadowbmaps[i];
				break;
			
			default:
				break;
		}
	}
	
	mainview.material = SM_Point_Main_mat;
	mainview.size_x = screen_size.x;
	mainview.size_y = screen_size.y;
	SM_Combine_mat.skin1 = bmap_createblack(screen_size.x,screen_size.y,24);
	mainview.bmap = SM_Combine_mat.skin1;
	set(mainview,VISIBLE);
	
	PP_Remove(SM_Combine_mat,camera,NULL);
	PP_Add(SM_Combine_mat,camera,NULL);
	
	SM_Combine_mat.skill1 = floatv(1);
	
	SM_Point_Active_var = 1;
	while(SM_Point_Active_var)
	{
		vec_set(mainview.x,camera.x);
		vec_set(mainview.pan,camera.pan);
		mainview.genius = camera.genius;
		mainview.clip_near = camera.clip_near;
		mainview.clip_far = camera.clip_far*0.2;
		mainview.arc = camera.arc;
		
		for(i = 0; i < numlights; i++)
		{
			if(view_to_light(shadowviews[i*6+0],i+1,NULL) == 0)
			{
				shadowviews[i*6+0].clip_far = 0;
			}
			
			shadowviews[i*6+0].clip_near = 0;
			SM_Point_setView(shadowviews[i*6+0], shadowviews[i*6+1]);
			SM_Point_setView(shadowviews[i*6+0], shadowviews[i*6+2]);
			SM_Point_setView(shadowviews[i*6+0], shadowviews[i*6+3]);
			SM_Point_setView(shadowviews[i*6+0], shadowviews[i*6+4]);
			SM_Point_setView(shadowviews[i*6+0], shadowviews[i*6+5]);
			
			switch(i)
			{
				case 0:
					SM_Point_Main_mat.skill1 = floatv(shadowviews[i*6+0].x);
					SM_Point_Main_mat.skill2 = floatv(shadowviews[i*6+0].z);
					SM_Point_Main_mat.skill3 = floatv(shadowviews[i*6+0].y);
					SM_Point_Main_mat.skill4 = floatv(shadowviews[i*6+0].clip_far);
					SM_Point_Main_mat.skill17 = floatv(1.0);
					break;
				
				case 1:
					SM_Point_Main_mat.skill5 = floatv(shadowviews[i*6+0].x);
					SM_Point_Main_mat.skill6 = floatv(shadowviews[i*6+0].z);
					SM_Point_Main_mat.skill7 = floatv(shadowviews[i*6+0].y);
					SM_Point_Main_mat.skill8 = floatv(shadowviews[i*6+0].clip_far);
					SM_Point_Main_mat.skill18 = floatv(1.0);
					break;
				
				case 2:
					SM_Point_Main_mat.skill9 = floatv(shadowviews[i*6+0].x);
					SM_Point_Main_mat.skill10 = floatv(shadowviews[i*6+0].z);
					SM_Point_Main_mat.skill11 = floatv(shadowviews[i*6+0].y);
					SM_Point_Main_mat.skill12 = floatv(shadowviews[i*6+0].clip_far);
					SM_Point_Main_mat.skill19 = floatv(1.0);
					break;
				
				case 3:
					SM_Point_Main_mat.skill13 = floatv(shadowviews[i*6+0].x);
					SM_Point_Main_mat.skill14 = floatv(shadowviews[i*6+0].z);
					SM_Point_Main_mat.skill15 = floatv(shadowviews[i*6+0].y);
					SM_Point_Main_mat.skill16 = floatv(shadowviews[i*6+0].clip_far);
					SM_Point_Main_mat.skill20 = floatv(1.0);
					break;
				
				default:
					break;
			}
		}
		
		wait(1);
	}
	
	SM_Combine_mat.skill1 = floatv(0);
	
	for(i = numlights*6-1; i >= 0; i--)
	{
		ptr_remove(shadowviews[i]);
		free(&(shadowviews[i]));
	}
	
	for(i = numlights*6-1; i >= 0; i--)
	{
		ptr_remove(shadowbmaps[i]);
		free(&(shadowbmaps[i]));
	}
}

#endif
