//////////////////////////////////////////////////
///////////////VSM Depthmapshader/////////////////
//////////////////////////////////////////////////
//////////////////////////////////////////////////
////24.12.2008////////////////by Nils Daumann/////
///////////////www.ssmasters.de///////////////////
//////////////////////////////////////////////////

// Constants given by the engine
float4x4 matWorldViewProj;
float4x4 matWorld;

float4 vecViewPos;

// Textures
texture entSkin1;
sampler ColorMapSampler = sampler_state
{
	Texture = <entSkin1>;
	MipFilter = LINEAR;
};

// Structs
struct SMapVertexToPixel
{
    float4 Position     : POSITION;
    float2 TexCoords    : TEXCOORD0;
    float3 WorldPos		: TEXCOORD1;
};

// Vertex Shader
SMapVertexToPixel ShadowMapVertexShader( float4 inPos : POSITION, float2 texcoords : TEXCOORD0)
{
    SMapVertexToPixel Output;
    
    Output.Position = mul(inPos,matWorldViewProj);
    Output.TexCoords = texcoords;
    
    Output.WorldPos = mul(inPos,matWorld);
    
    return Output;
}

// Pixel Shader
float4 ShadowMapPixelShader(SMapVertexToPixel PSIn) : COLOR0
{
	clip(tex2D(ColorMapSampler,PSIn.TexCoords.xy).a-0.5);
	
	float4 Color;
	Color.r = distance(PSIn.WorldPos,vecViewPos.xyz);
	Color.g = Color.r*Color.r;
	Color.b = 1.0;
	Color.a = 1.0;

	return Color;
}


// Technique
technique ShadowMap
{
	pass Pass0
	{
		ZWriteEnable = True;
		AlphaBlendEnable = False;
		AlphaTestEnable = False;
		
		CullMode = CCW;
		
		VertexShader = compile vs_2_0 ShadowMapVertexShader();
		PixelShader = compile ps_2_0 ShadowMapPixelShader();
	}
}